;;; - ------------------------------------------------------------------------------ - ;
;;; -                           T O O L - Z O O M O                                  - ;
;;; - ------------------------------------------------------------------------------ - ;
;;; - Beschreibung :  Zoom to Object                                                 - ;
;;; -                 Zoomt Ansichtsfenster auf die ausgewhlten Objekte             - ;
;;; - ------------------------------------------------------------------------------ - ;
;;; - letzte nderung am : 05.04.2005                                                - ;
;;; -              durch : Thomas Krger                                             - ;
;;; - ------------------------------------------------------------------------------ - ;
(vl-load-com)

;;; - ------------------------------------------------------------------------------ - ;
;;; - Funktionsname : ZoomO                                                          - ;
;;; - Beschreibung  : Zoomt Ansichtsfenster auf die ausgewhlten Objekte             - ;
;;; - Parameter     : AUSWAHL [PICKSET]  / [VLA-SELECTIONSET]                        - ;
;;; - Rckgabe      : Keine                                                          - ;
;;; - ------------------------------------------------------------------------------ - ;
(defun ZoomO (  AUSWAHL / INDEX elem  xmin xmax MINX MAXX MINY MAXY)
  (if(setq AUSWAHL
       (cond
         ((=(type AUSWAHL)'PICKSET)
           (repeat (sslength AUSWAHL)
             (setq INDEX -1)   
             (setq VLA-OBJLIST
               (cons
                 (vlax-ename->vla-object(ssname AUSWAHL(setq INDEX (1+ INDEX))))
                 VLA-OBJLIST
               )
             )
           )
           (reverse VLA-OBJLIST)
         ) 
         ((and(=(type AUSWAHL)'VLA-OBJECT)(vlax-method-applicable-p AUSWAHL 'SELECT))
           (vlax-for ITEM AUSWAHL
             (setq VLA-OBJLIST(cons
                                ITEM
                                VLA-OBJLIST
                              )
             )                         
           )
           (reverse VLA-OBJLIST)
         )
       )
     )
    (progn      
      (setq INDEX 0)
      (foreach ELEM AUSWAHL        
        (vla-getboundingbox 
          ELEM
          'xmin
          'xmax
        )
        (if (= INDEX 0)
          (progn            
            (setq MINX (car (vlax-safearray->list xmin)))
            (setq MINY (cadr(vlax-safearray->list xmin)))
            (setq MAXX (car (vlax-safearray->list xmax)))
            (setq MAXY (cadr(vlax-safearray->list xmax)))
          )
          (progn
            (if (<(car (vlax-safearray->list xmin)) MINX)
              (setq MINX (car (vlax-safearray->list xmin)))
            )
            (if (<(cadr(vlax-safearray->list xmin)) MINY)
              (setq MINY (cadr(vlax-safearray->list xmin))) 
            )
            (if (>(car (vlax-safearray->list xmax)) MAXX)
              (setq MAXX (car (vlax-safearray->list xmax)))
            )
            (if (>(cadr(vlax-safearray->list xmax)) MAXY)
              (setq MAXY (cadr(vlax-safearray->list xmax)))
            )
          ) 
        )
        (setq INDEX (1+ INDEX))
      )        
      (vl-catch-all-error-p
        (vl-catch-all-apply
          'vla-ZoomWindow
          (list (vlax-get-acad-object)                
                (vlax-3D-Point(list MINX MINY))
                (vlax-3D-Point(list MAXX MAXY))
          )      
        )
      )
    )
  )
)
;;; - ------------------------------------------------------------------------------ - ;

;;; - ------------------------------------------------------------------------------ - ;
;;; - Funktionsname : C:ZoomO                                                        - ;
;;; - Beschreibung  : Zoomt Ansichtsfenster auf die ausgewhlten Objekte             - ;
;;; - Parameter     : Keine                                                          - ;
;;; - Rckgabe      : Keine                                                          - ;
;;; - ------------------------------------------------------------------------------ - ;
(defun C:ZoomO ( / AUSWAHL)    
  (if(or(and(setq AUSWAHL (ssget "I"))(>(sslength AUSWAHL) 0))
        (and(setq AUSWAHL (ssget))    (>(sslength AUSWAHL) 0))
     )
    (progn
      (vla-endundomark (vla-get-activedocument(vlax-get-acad-object)))
      (vla-startundomark(vla-get-activedocument(vlax-get-acad-object)))
      (ZoomO AUSWAHL)
      (vla-endundomark(vla-get-activedocument(vlax-get-acad-object)))
    )  
  )
)
;;; - ------------------------------------------------------------------------------ - ;;


;;; - ------------------------------------------------------------------------------ - ;
;;; - VLA-Variante                                                                   - ;
;;; - Funktionsname : C:ZoomO-2                                                      - ;
;;; - Beschreibung  : Zoomt Ansichtsfenster auf die ausgewhlten Objekte - VLA-Var   - ;
;;; - Parameter     : Keine                                                          - ;
;;; - Rckgabe      : Keine                                                          - ;
;;; - ------------------------------------------------------------------------------ - ;
;;;(defun C:ZoomO-2 ( / SSET SSETNAME)    
;;;  (setq SSETNAME "SSET")
;;;  (vlax-for ITEM
;;;    (vla-get-selectionsets(vla-get-activedocument(vlax-get-acad-object)))
;;;    (if (=(vla-get-name ITEM) SSETNAME) (vla-delete ITEM))
;;;  )
;;;  (if(setq SSET
;;;       (vla-add
;;;          (vla-get-selectionsets(vla-get-activedocument(vlax-get-acad-object)))  
;;;          SSETNAME
;;;       )
;;;     )
;;;    (progn
;;;      (vla-selectOnScreen SSET)
;;;      (ZoomO SSET)     
;;;    )  
;;;  )  
;;;)
;;; - ------------------------------------------------------------------------------ - ;

(princ(strcat
          "ZOOMO: Zoomt auf ausgewhlte/zu whlende Objekte\n"
          "(C) Thomas Krger ( tk@cad-od.de )\n\n"
          "Befehlszeilenaufruf :  ZoomO                        \n"
      )
)
(princ)
